/***************************************************************************
| File: SCT.js
| Author(s): The Taproot Foundation
|   
| Purpose: This javascript file implements the banner animation and navigation, 
|          and preloads the images for the SCT website.
|
| Modification History
|===========================================================================
| Date         Author       Change 
|===========================================================================
| 10 Mar 2011	KSB	    Created.		
|***************************************************************************/

var images = 0;
var timeout = 10000;
var currentBanner = -1;
var busy = false;

onload = function()
{
  imagePreload();
  initBannerFade();
  initBannerBottomNav();
};


imagePreload = function()
{
  // set image url
  var image_url = new Array();
  var imagepath = "/images/banners/";
  image_url[0] = imagepath + "banner_DramaSchool.png";
  image_url[1] = imagepath + "banner_Events.png";
  image_url[2] = imagepath + "banner_ForEducators.png";
  image_url[3] = imagepath + "banner_Show.png";

  // preload images 
  var preload_image_object = new Array();
  for (var i = 0; i < image_url.length; i++) 
    {
      preload_image_object[i] = new Image();
      preload_image_object[i].src = image_url[i];
    }  
};

initBannerFade = function()
{
  images = new initImage("/images/banners/Home_banner1.png", 
			 "/images/banners/Home_banner2.png",
			 "/images/banners/Home_banner3.png", 
			 "/images/banners/Home_banner4.png",
			 "/images/banners/Home_banner4.png",
			 "/images/banners/Home_banner4.png" );
  
  // make the first image visible 
  $(".main-image").attr( {src: images[0]} );
  var obj = {"opacity": "1"};
  $(".main-image").css(obj);
  
  rotate(0);
  var timer = setTimeout("switchImages(0)", timeout);
}; 

initImage = function()
{
  this.length = initImage.arguments.length;
  for (var i = 0; i < this.length; i++) 
    {
      this[i] = initImage.arguments[i];
    }
};

rotate = function(ids)
{
  currentBanner = ids;
  var oldsrc = $(".main-image").attr("src");
  // set the underlying image to the previous on-top image
  $(".banner-cover").attr( {src: oldsrc} );  
  
  // set the current image to the new one, while fading out the previous one
  var obj = {"opacity": "0.1"};
  $(".main-image").css(obj);
  $(".main-image").attr( {src: images[ids]} );
  $(".main-image").stop().animate({opacity:"1"}, {duration:2000});  
};


switchImages = function(ids)
{
  if(currentBanner > -1)
    {
      ids = currentBanner;
      currentBanner = -1;
    }
  
  if(!busy)
    {
      if ( ids < (images.length-1) && ids >= 0) { ids++;}
      else {ids = 0;}            
      rotate(ids);
    }
  
  var timer = setTimeout("switchImages(" + ids + ")", timeout);
};


initBannerBottomNav = function()
{
  
  var tmp = document.getElementById('banner-bottom');
  cn = tmp.childNodes;
  for(var i=0; i<cn.length; i++)
    {
      if(cn[i].tagName == 'SPAN')
	{ 
	  cn[i].onmouseover = bannerNavMouseOver;
	  cn[i].onmouseout = bannerNavMouseOut;
	  cn[i].onclick = bannerNavClick;
	}
    }
};

bannerNavMouseOver = function(e, inputId)
{
  var targ;
  if (!e) {var e = window.event;}  
  if (e.target) { targ = e.target; } 
  else if (e.srcElement) {  targ = e.srcElement;}
  pn = targ.parentNode;
  if(pn.nodeName == 'SPAN')
    {
      if (pn.className == 'banner-bottom-nav-normal')
	{
	  targ.src = "/images/button_bannernav_selected.png";
	} 
    } 
};
  
bannerNavMouseOut = function(e, inputId)
{
  var targ;
  if (!e) {var e = window.event;}  
  if (e.target) { targ = e.target; } 
  else if (e.srcElement) {  targ = e.srcElement;}
  pn = targ.parentNode;
  if(pn.nodeName == 'SPAN')
    {
      if (pn.className == 'banner-bottom-nav-normal')
	{
	  targ.src = "/images/button_bannernav.png";
	} 
    } 
};


bannerNavClick = function(e, inputId)
{
  var targ;
  if (!e) {var e = window.event;}  
  if (e.target) { targ = e.target; } 
  else if (e.srcElement) {  targ = e.srcElement;}

  var cbs;
  var cbi;
  // get the span and img tags associated with the item that was clicked
  if(targ.nodeName == 'IMG') 
    {
      cbs = targ.parentNode;
      cbi = targ;
    }
  else if (targ.nodeName == 'SPAN')
    {
      cbs = targ;
      if(targ.hasChildNodes)
	{
	  cn = targ.childNodes;
	  var c = 0;
	  while(cn[c].nodeName != 'IMG' && c<cn[c].length)
	    {
	      c++;
	    }
	  cbi = cn[c];  
	}
    }
  
  // Check if the button clicked was not active
  if (cbs.className == 'banner-bottom-nav-normal')
    { 
      // Set the currently active button to normal
      var bbarray=  document.getElementById('banner-bottom');
      cn = bbarray.childNodes;
      for(var i=0; i<cn.length; i++)
	{
	  if(cn[i].tagName == 'SPAN' && cn[i].className == 'banner-bottom-nav-active') 
	    {
	      var bnav = cn[i].childNodes;
	      for(c=0; c<bnav.length; c++)
		{
		  if(bnav[c].tagName == "IMG")
		    {
		      bnav[c].src = "/images/button_bannernav.png";
		    }
		}      
	      cn[i].className = 'banner-bottom-nav-normal';  
	    } 
	}
      // set the clicked button to be active
      cbi.src = "/images/button_bannernav_selected.png";

      // set the image associated with the button clicked, to be visible in the banner
      var main_image = document.getElementById('main-image');
      cn = main_image.childNodes;
      for(var i=0; i<cn.length; i++)
	{
	  if(cn[i].tagName == "IMG" && cn[i].className == 'main-image')
	    {
	      var img = images[parseInt(cbs.id) - 1];
	      cn[i].src = img;
	    }	
	}  
      cbs.className = 'banner-bottom-nav-active'; 
    } 
};
